com.google.gwt.core.client

## Class JsDate

- java.lang.Object
- - com.google.gwt.core.client.JavaScriptObject
  - - com.google.gwt.core.client.JsDate

-     public class JsDate
      extends JavaScriptObject

  A simple wrapper around a native JS Date object.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JsDate()` Non directly instantiable, use one of the `create()` methods.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static JsDate` | `create()` Creates a new date with the current time.
    `static JsDate` | `create(double milliseconds)` Creates a new date with the specified internal representation, which is the number of milliseconds since midnight on January 1st, 1970.
    `static JsDate` | `create(int year, int month)` Creates a new date using the specified values.
    `static JsDate` | `create(int year, int month, int dayOfMonth)` Creates a new date using the specified values.
    `static JsDate` | `create(int year, int month, int dayOfMonth, int hours)` Creates a new date using the specified values.
    `static JsDate` | `create(int year, int month, int dayOfMonth, int hours, int minutes)` Creates a new date using the specified values.
    `static JsDate` | `create(int year, int month, int dayOfMonth, int hours, int minutes, int seconds)` Creates a new date using the specified values.
    `static JsDate` | `create(int year, int month, int dayOfMonth, int hours, int minutes, int seconds, int millis)` Creates a new date using the specified values.
    `static JsDate` | `create(java.lang.String dateString)` Creates a new date from a string to be parsed.
    `int` | `getDate()` Returns the day of the month.
    `int` | `getDay()` Returns the day of the week, from `0` (Sunday) to `6` Saturday.
    `int` | `getFullYear()` Returns the four-digit year.
    `int` | `getHours()` Returns the hour, between `0` (midnight) and `23`.
    `int` | `getMilliseconds()` Returns the milliseconds, between `0` and `999`.
    `int` | `getMinutes()` Returns the minutes, between `0` and `59`.
    `int` | `getMonth()` Returns the month, from `0` (January) to `11` December.
    `int` | `getSeconds()` Returns the seconds, between `0` and `59`.
    `double` | `getTime()` Returns the internal millisecond representation of the date, the number of milliseconds since midnight on January 1st, 1970.
    `int` | `getTimezoneOffset()` Returns the difference, in minutes, between the local and UTC representations of this date.
    `int` | `getUTCDate()` Returns the day of the month, in UTC.
    `int` | `getUTCDay()` Returns the day of the week, from `0` (Sunday) to `6` Saturday, in UTC.
    `int` | `getUTCFullYear()` Returns the four-digit year, in UTC.
    `int` | `getUTCHours()` Returns the hour, between `0` (midnight) and `23`, in UTC.
    `int` | `getUTCMilliseconds()` Returns the milliseconds, between `0` and `999`, in UTC.
    `int` | `getUTCMinutes()` Returns the minutes, between `0` and `59`, in UTC.
    `int` | `getUTCMonth()` Returns the month, from `0` (January) to `11` December, in UTC.
    `int` | `getUTCSeconds()` Returns the seconds, between `0` and `59`, in UTC.
    `int` | `getYear()` Deprecated. Use `getFullYear()`.
    `static double` | `now()` Returns the numeric value corresponding to the current time - the number of milliseconds elapsed since 1 January 1970 00:00:00 UTC.
    `static double` | `parse(java.lang.String dateString)` Parses a string representation of a date and time and returns the internal millisecond representation.
    `double` | `setDate(int dayOfMonth)` Sets the day of the month.
    `double` | `setFullYear(int year)` Sets the year.
    `double` | `setFullYear(int year, int month)` Sets the year and month.
    `double` | `setFullYear(int year, int month, int day)` Sets the year, month, and day.
    `double` | `setHours(int hours)` Sets the hour.
    `double` | `setHours(int hours, int mins)` Sets the hour and minutes.
    `double` | `setHours(int hours, int mins, int secs)` Sets the hour, minutes, and seconds.
    `double` | `setHours(int hours, int mins, int secs, int ms)` Sets the hour, minutes, seconds, and milliseconds.
    `double` | `setMinutes(int minutes)` Sets the minutes.
    `double` | `setMinutes(int minutes, int seconds)` Sets the minutes and seconds.
    `double` | `setMinutes(int minutes, int seconds, int millis)` Sets the minutes, seconds, and milliseconds.
    `double` | `setMonth(int month)` Sets the month.
    `double` | `setMonth(int month, int dayOfMonth)` Sets the month and day.
    `double` | `setSeconds(int seconds)` Sets the seconds.
    `double` | `setSeconds(int seconds, int millis)` Sets the seconds and milliseconds.
    `double` | `setTime(double milliseconds)` Sets the internal date representation.
    `double` | `setUTCDate(int dayOfMonth)` Sets the day of the month, in UTC.
    `double` | `setUTCFullYear(int year)` Sets the year, in UTC.
    `double` | `setUTCFullYear(int year, int month)` Sets the year and month, in UTC.
    `double` | `setUTCFullYear(int year, int month, int day)` Sets the year, month, and day, in UTC.
    `double` | `setUTCHours(int hours)` Sets the hour, in UTC.
    `double` | `setUTCHours(int hours, int mins)` Sets the hour and minutes, in UTC.
    `double` | `setUTCHours(int hours, int mins, int secs)` Sets the hour, minutes, and seconds, in UTC.
    `double` | `setUTCHours(int hours, int mins, int secs, int ms)` Sets the hour, minutes, seconds, and milliseconds, in UTC.
    `double` | `setUTCMinutes(int minutes)` Sets the minutes, in UTC.
    `double` | `setUTCMinutes(int minutes, int seconds)` Sets the minutes and seconds, in UTC.
    `double` | `setUTCMinutes(int minutes, int seconds, int millis)` Sets the minutes, seconds, and milliseconds, in UTC.
    `double` | `setUTCMonth(int month)` Sets the month, in UTC.
    `double` | `setUTCMonth(int month, int dayOfMonth)` Sets the month and day, in UTC.
    `double` | `setUTCSeconds(int seconds)` Sets the seconds, in UTC.
    `double` | `setUTCSeconds(int seconds, int millis)` Sets the seconds and milliseconds, in UTC.
    `double` | `setYear(int year)` Deprecated. Use `setFullYear(int)`.
    `java.lang.String` | `toDateString()` Returns a date string in the local time zone.
    `java.lang.String` | `toGMTString()` Deprecated. Use `toUTCString()`.
    `java.lang.String` | `toLocaleDateString()` Returns a date string in the local time zone according to local formatting conventions.
    `java.lang.String` | `toLocaleString()` Returns a date and time string in the local time zone according to local formatting conventions.
    `java.lang.String` | `toLocaleTimeString()` Returns a time string in the local time zone according to local formatting conventions.
    `java.lang.String` | `toTimeString()` Returns a time string in the local time zone.
    `java.lang.String` | `toUTCString()` Returns a date and time string in UTC.
    `static double` | `UTC(int year, int month, int dayOfMonth, int hours, int minutes, int seconds, int millis)` Returns the internal millisecond representation of the specified UTC date and time.
    `double` | `valueOf()` Returns the millisecond representation, as `getTime()`.

    - ### Methods inherited from class com.google.gwt.core.client.JavaScriptObject

      `cast, createArray, createArray, createFunction, createObject, equals, hashCode, toSource, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### JsDate

          protected JsDate()

      Non directly instantiable, use one of the `create()` methods.

  - ### Method Detail

    - #### create

          public static JsDate create()

      Creates a new date with the current time.

    - #### create

          public static JsDate create(double milliseconds)

      Creates a new date with the specified internal representation, which is the number of milliseconds since midnight on January 1st, 1970. This is the same representation returned by `getTime()`.

    - #### create

          public static JsDate create(int year,
                                      int month)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(int year,
                                      int month,
                                      int dayOfMonth)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(int year,
                                      int month,
                                      int dayOfMonth,
                                      int hours)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(int year,
                                      int month,
                                      int dayOfMonth,
                                      int hours,
                                      int minutes)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(int year,
                                      int month,
                                      int dayOfMonth,
                                      int hours,
                                      int minutes,
                                      int seconds)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(int year,
                                      int month,
                                      int dayOfMonth,
                                      int hours,
                                      int minutes,
                                      int seconds,
                                      int millis)

      Creates a new date using the specified values.

    - #### create

          public static JsDate create(java.lang.String dateString)

      Creates a new date from a string to be parsed.

    - #### now

          public static double now()

      Returns the numeric value corresponding to the current time - the number of milliseconds elapsed since 1 January 1970 00:00:00 UTC.

    - #### parse

          public static double parse(java.lang.String dateString)

      Parses a string representation of a date and time and returns the internal millisecond representation. If the string cannot be parsed, the returned value will be `NaN`. Use `Double.isNaN(double)` to check the result.

    - #### UTC

          public static double UTC(int year,
                                   int month,
                                   int dayOfMonth,
                                   int hours,
                                   int minutes,
                                   int seconds,
                                   int millis)

      Returns the internal millisecond representation of the specified UTC date and time.

    - #### getDate

          public final int getDate()

      Returns the day of the month.

    - #### getDay

          public final int getDay()

      Returns the day of the week, from `0` (Sunday) to `6` Saturday.

    - #### getFullYear

          public final int getFullYear()

      Returns the four-digit year.

    - #### getHours

          public final int getHours()

      Returns the hour, between `0` (midnight) and `23`.

    - #### getMilliseconds

          public final int getMilliseconds()

      Returns the milliseconds, between `0` and `999`.

    - #### getMinutes

          public final int getMinutes()

      Returns the minutes, between `0` and `59`.

    - #### getMonth

          public final int getMonth()

      Returns the month, from `0` (January) to `11` December.

    - #### getSeconds

          public final int getSeconds()

      Returns the seconds, between `0` and `59`.

    - #### getTime

          public final double getTime()

      Returns the internal millisecond representation of the date, the number of milliseconds since midnight on January 1st, 1970. This is the same representation returned by `getTime()`.

    - #### getTimezoneOffset

          public final int getTimezoneOffset()

      Returns the difference, in minutes, between the local and UTC representations of this date. The value returned is affected by whether or not daylight savings time would be in effect on specified date.

    - #### getUTCDate

          public final int getUTCDate()

      Returns the day of the month, in UTC.

    - #### getUTCDay

          public final int getUTCDay()

      Returns the day of the week, from `0` (Sunday) to `6` Saturday, in UTC.

    - #### getUTCFullYear

          public final int getUTCFullYear()

      Returns the four-digit year, in UTC.

    - #### getUTCHours

          public final int getUTCHours()

      Returns the hour, between `0` (midnight) and `23`, in UTC.

    - #### getUTCMilliseconds

          public final int getUTCMilliseconds()

      Returns the milliseconds, between `0` and `999`, in UTC.

    - #### getUTCMinutes

          public final int getUTCMinutes()

      Returns the minutes, between `0` and `59`, in UTC.

    - #### getUTCMonth

          public final int getUTCMonth()

      Returns the month, from `0` (January) to `11` December, in UTC.

    - #### getUTCSeconds

          public final int getUTCSeconds()

      Returns the seconds, between `0` and `59`, in UTC.

    - #### getYear

          @Deprecated
          public final int getYear()

      Deprecated. Use `getFullYear()`.
      Returns the year minus 1900.

    - #### setDate

          public final double setDate(int dayOfMonth)

      Sets the day of the month. Returns the millisecond representation of the adjusted date.

    - #### setFullYear

          public final double setFullYear(int year)

      Sets the year. Returns the millisecond representation of the adjusted date.

    - #### setFullYear

          public final double setFullYear(int year,
                                          int month)

      Sets the year and month. Returns the millisecond representation of the adjusted date.

    - #### setFullYear

          public final double setFullYear(int year,
                                          int month,
                                          int day)

      Sets the year, month, and day. Returns the millisecond representation of the adjusted date.

    - #### setHours

          public final double setHours(int hours)

      Sets the hour. Returns the millisecond representation of the adjusted date.

    - #### setHours

          public final double setHours(int hours,
                                       int mins)

      Sets the hour and minutes. Returns the millisecond representation of the adjusted date.

    - #### setHours

          public final double setHours(int hours,
                                       int mins,
                                       int secs)

      Sets the hour, minutes, and seconds. Returns the millisecond representation of the adjusted date.

    - #### setHours

          public final double setHours(int hours,
                                       int mins,
                                       int secs,
                                       int ms)

      Sets the hour, minutes, seconds, and milliseconds. Returns the millisecond representation of the adjusted date.

    - #### setMinutes

          public final double setMinutes(int minutes)

      Sets the minutes. Returns the millisecond representation of the adjusted date.

    - #### setMinutes

          public final double setMinutes(int minutes,
                                         int seconds)

      Sets the minutes and seconds. Returns the millisecond representation of the adjusted date.

    - #### setMinutes

          public final double setMinutes(int minutes,
                                         int seconds,
                                         int millis)

      Sets the minutes, seconds, and milliseconds. Returns the millisecond representation of the adjusted date.

    - #### setMonth

          public final double setMonth(int month)

      Sets the month. Returns the millisecond representation of the adjusted date.

    - #### setMonth

          public final double setMonth(int month,
                                       int dayOfMonth)

      Sets the month and day. Returns the millisecond representation of the adjusted date.

    - #### setSeconds

          public final double setSeconds(int seconds)

      Sets the seconds. Returns the millisecond representation of the adjusted date.

    - #### setSeconds

          public final double setSeconds(int seconds,
                                         int millis)

      Sets the seconds and milliseconds. Returns the millisecond representation of the adjusted date.

    - #### setTime

          public final double setTime(double milliseconds)

      Sets the internal date representation. Returns the `milliseconds` argument.

    - #### setUTCDate

          public final double setUTCDate(int dayOfMonth)

      Sets the day of the month, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCFullYear

          public final double setUTCFullYear(int year)

      Sets the year, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCFullYear

          public final double setUTCFullYear(int year,
                                             int month)

      Sets the year and month, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCFullYear

          public final double setUTCFullYear(int year,
                                             int month,
                                             int day)

      Sets the year, month, and day, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCHours

          public final double setUTCHours(int hours)

      Sets the hour, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCHours

          public final double setUTCHours(int hours,
                                          int mins)

      Sets the hour and minutes, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCHours

          public final double setUTCHours(int hours,
                                          int mins,
                                          int secs)

      Sets the hour, minutes, and seconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCHours

          public final double setUTCHours(int hours,
                                          int mins,
                                          int secs,
                                          int ms)

      Sets the hour, minutes, seconds, and milliseconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCMinutes

          public final double setUTCMinutes(int minutes)

      Sets the minutes, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCMinutes

          public final double setUTCMinutes(int minutes,
                                            int seconds)

      Sets the minutes and seconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCMinutes

          public final double setUTCMinutes(int minutes,
                                            int seconds,
                                            int millis)

      Sets the minutes, seconds, and milliseconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCMonth

          public final double setUTCMonth(int month)

      Sets the month, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCMonth

          public final double setUTCMonth(int month,
                                          int dayOfMonth)

      Sets the month and day, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCSeconds

          public final double setUTCSeconds(int seconds)

      Sets the seconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setUTCSeconds

          public final double setUTCSeconds(int seconds,
                                            int millis)

      Sets the seconds and milliseconds, in UTC. Returns the millisecond representation of the adjusted date.

    - #### setYear

          @Deprecated
          public final double setYear(int year)

      Deprecated. Use `setFullYear(int)`.
      Sets a two-digit year.

    - #### toDateString

          public final java.lang.String toDateString()

      Returns a date string in the local time zone.

    - #### toGMTString

          @Deprecated
          public final java.lang.String toGMTString()

      Deprecated. Use `toUTCString()`.
      Returns a date and time string in GMT.

    - #### toLocaleDateString

          public final java.lang.String toLocaleDateString()

      Returns a date string in the local time zone according to local formatting conventions.

    - #### toLocaleString

          public final java.lang.String toLocaleString()

      Returns a date and time string in the local time zone according to local formatting conventions.

    - #### toLocaleTimeString

          public final java.lang.String toLocaleTimeString()

      Returns a time string in the local time zone according to local formatting conventions.

    - #### toTimeString

          public final java.lang.String toTimeString()

      Returns a time string in the local time zone.

    - #### toUTCString

          public final java.lang.String toUTCString()

      Returns a date and time string in UTC.

    - #### valueOf

          public final double valueOf()

      Returns the millisecond representation, as `getTime()`.